/*
 *  linux/include/asm-arm/arch-pxa/possio_px30.h
 *
 *  Author:	
 *  Created:
 *  Copyright:	Possio AB 
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * Originally based on: linux/include/asm-arm/arch-pxa/lubbock.h
 * 
 */

#define POSSIO_PX30_ETH_BASE	(0xf1000000)	/* phys 0x0c000000 */
#define POSSIO_PX30_SA1111_BASE	(0xf4000000)	/* phys 0x10000000 */

/* GPIOs */


#define POSSIO_PX30_BUTTON_GPIO	0
#define POSSIO_PX30_BUTTON_IRQ	IRQ_GPIO(0)
#define PX_BUTTON	POSSIO_PX30_BUTTON_GPIO

#define GPIO_POSSIO_PX30_IRQ	1
#define IRQ_GPIO_POSSIO_PX30_IRQ	IRQ_GPIO(1)

#define GPIO_ETH_POSSIO_PX30_IRQ	2
#define IRQ_ETH_POSSIO_PX30_IRQ	IRQ_GPIO(2)

/* SA1111 INT is connected to gpio1 */
#define POSSIO_PX30_SA1111_IRQ	IRQ_GPIO(1)
#define POSSIO_PX30_ETH_IRQ		IRQ_GPIO(2)


#define POSSIO_PX30_IRDA_FIR_SEL_GPIO	58
#define POSSIO_PX30_IRDA_MD0_GPIO		59
#define POSSIO_PX30_IRDA_MD1_GPIO		60

#define POSSIO_PX30_IRDA_FIR_SEL		GPIO_bit(POSSIO_PX30_IRDA_FIR_SEL_GPIO)
#define POSSIO_PX30_IRDA_MD0			GPIO_bit(POSSIO_PX30_IRDA_MD0_GPIO)
#define POSSIO_PX30_IRDA_MD1			GPIO_bit(POSSIO_PX30_IRDA_MD1_GPIO)


#define POSSIO_PX30_KEEP_ON_GPIO	61
#define POSSIO_PX30_LED_BLUE_GPIO   73
#define POSSIO_PX30_LED_GREEN_GPIO	75
#define POSSIO_PX30_LED_RED_GPIO	77

#define POSSIO_PX30_LED_RED		GPIO_bit(POSSIO_PX30_LED_RED_GPIO)
#define POSSIO_PX30_LED_GREEN   GPIO_bit(POSSIO_PX30_LED_GREEN_GPIO)
#define POSSIO_PX30_LED_BLUE    GPIO_bit(POSSIO_PX30_LED_BLUE_GPIO)


#define __REDLED_ON		GPCR(POSSIO_PX30_LED_RED_GPIO)	|= POSSIO_PX30_LED_RED;
#define __REDLED_OFF		GPSR(POSSIO_PX30_LED_RED_GPIO)	|= POSSIO_PX30_LED_RED;
#define __GREENLED_ON	GPCR(POSSIO_PX30_LED_GREEN_GPIO)|= POSSIO_PX30_LED_GREEN;
#define __GREENLED_OFF	GPSR(POSSIO_PX30_LED_GREEN_GPIO)|= POSSIO_PX30_LED_GREEN;
#define __BLUELED_ON    GPSR(POSSIO_PX30_LED_BLUE_GPIO)	|= POSSIO_PX30_LED_BLUE;
#define __BLUELED_OFF   GPCR(POSSIO_PX30_LED_BLUE_GPIO)	|= POSSIO_PX30_LED_BLUE;

#define POSSIO_PX30_RED_ON		__GREENLED_OFF; __REDLED_ON;
#define POSSIO_PX30_RED_OFF     __REDLED_OFF;
#define POSSIO_PX30_GREEN_ON    __REDLED_OFF;__GREENLED_ON
#define POSSIO_PX30_GREEN_OFF   __GREENLED_OFF;
#define POSSIO_PX30_BLUE_ON     __BLUELED_ON;
#define POSSIO_PX30_BLUE_OFF    __BLUELED_OFF;

#define POSSIO_PX30_LEDMASK 	(POSSIO_PX30_LED_RED | POSSIO_PX30_LED_GREEN | POSSIO_PX30_LED_BLUE )
#define POSSIO_PX30_LEDS		(GPLR(POSSIO_PX30_LED_RED_GPIO) & POSSIO_PX30_LEDMASK)

#define POSSIO_PX30_KEEP_ON(x)	{x==1 ?	GPCR(POSSIO_PX30_KEEP_ON_GPIO)= GPIO_bit(POSSIO_PX30_KEEP_ON_GPIO) : \
										GPSR(POSSIO_PX30_KEEP_ON_GPIO)= GPIO_bit(POSSIO_PX30_KEEP_ON_GPIO);}

